#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from .models import Attestation as AttestationModel
from django.contrib import admin



class Attestation(admin.ModelAdmin):

    list_display        = ('id', 'number', 'experiment', 'locked', 'creation_date', 'expiration_date', 'publication_date',)
    search_fields       = [
                           'number',
                           'experiment__name',
                           'experiment__author__username',
                           'experiment__toolchain__author__username',
                           'experiment__toolchain__name',
                           'experiment__toolchain__version',
                           ]
    list_filter         = ('locked', )
    list_display_links  = ('id', 'number')

admin.site.register(AttestationModel, Attestation)
