/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */
//Directive for opening smart_selector list on "Add a report item" button click that displays options

angular.module('reportApp').directive("addreportitem", function($compile){
	return function(scope, element, attrs){
		scope.$on("addSavedElement", function(event, id_content, type){
			let num_tables_in_content = 0;
			let num_figures_in_content = 0;
			for(let i = 0; i < Object.keys(scope.report.content).length; i++){
				if(Object.keys(scope.report.content)[i].indexOf("table_") == 0){
					num_tables_in_content++;
				}
				else if(Object.keys(scope.report.content)[i].indexOf("chart_") == 0){
					num_figures_in_content++;
				}
			}

			if(type == "table"){
				let table_id = id_content;
				let table_details = undefined;

				//take the one with more elements
				if(Object.keys(scope.tables_details).length > num_tables_in_content){
					table_details = scope.tables_details[id_content];
				}
				else{
					table_details = scope.report.content[id_content];
				}

				let name_to_remove = "experiment";
				for(let i = 0; i < table_details.length; i++){
					if(table_details[i].name == "experiment"){
						table_details.splice(i,1);
						break;
					}
				}

				scope.tables_details[table_id] = table_details;

				let accessnumber = "no_number";
				if(scope.report.number == scope.report_number){
					accessnumber = "number";
				}
				let html_div_code = '<div class="panel panel-default" id="' + table_id + '"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#info-heading" href="#collapse-' + table_id + '" aria-expanded="true" aria-controls="collapse-info"><i class="fa fa-table"> Table</i></a></h4></div><div id="collapse-' + table_id + '" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="info-heading"><div class="panel-body" table-dynamic monster=' + scope.num_report_items + " tableid=" + table_id + " reportstatus=" + scope.report.status + " accessnumber=" + accessnumber + " urlprefix=" + scope.url_prefix + '></div></div></div>';

				angular.element(document.getElementById('space-for-report-items')).append($compile(html_div_code)(scope));
				if(parseInt(table_id.split("_").pop(-1)) >= scope.max_num){
					scope.max_num = parseInt(table_id.split("_").pop(-1));
					scope.num_report_items = scope.max_num;
				}

				scope.num_report_items++;


			}
			else if(type == "chart"){

				let content_detail = {};
				let chart_id = id_content;

				let plot_details = undefined;

				//take the one with more elements
				if(Object.keys(scope.plots_details).length > num_figures_in_content){
					plot_details = scope.plots_details[chart_id];
				}
				else{
					plot_details = scope.report.content[chart_id];
				}



				content_detail["name"] = plot_details.data.output[0];
				//content_detail["description"] = scope.report.content[chart_id].data.plotter;
				if(plot_details.data.plotter != undefined){
					content_detail["selected_plotter"] = plot_details.data.plotter;
				}
				if(plot_details.selected_template != undefined){
					content_detail["selected_template"] = plot_details.selected_template;
				}
				if(plot_details.data.merged != undefined){
					content_detail["merged"] = plot_details.data.merged;
				}
				if(plot_details.merged != undefined){
					content_detail["merged"] = plot_details.merged;
				}

				let html_div_code = '<div class="panel panel-default" id="' + chart_id + '"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#info-heading" href="#collapse-' + chart_id + '" aria-expanded="true" aria-controls="collapse-info"><i class="fa fa-area-chart"> ' + content_detail.name + '</i></a></h4></div><div id="collapse-' + chart_id + '" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="info-heading"><div id="'+chart_id+'" class="panel-body chart {$ report.status $}"></div></div></div>';
				generate_element(scope, "plot", html_div_code);
				let element = document.getElementById(chart_id);
				let label_element  = $(document.createElement('div'));
				label_element.addClass('row');

				let accessnumber = "no_number";
				if(scope.report.number == scope.report_number){
					accessnumber = "number";
				}

				let prepend_buttons = '<div class="col-sm-12"><div class="action-buttons report-buttons pull-left">';
				let append_buttons = '</div></div>';

				let a_export  = '<div class="btn-group"><button type="button" class="btn btn-primary btn-sm dropdown-toggle item_export ' + scope.report.status + ' ' + accessnumber + '" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fa fa-download fa-lg"></i> Export Figure <span class="caret"></span></button><ul class="dropdown-menu"><li id="PNG" buttonexportitem><a>PNG</a></li><li id="JPEG" buttonexportitem><a>JPEG</a></li><li id="PDF" buttonexportitem><a>PDF</a></li></ul></div>';
				if(scope.report.status == "editable" && scope.report.number != scope.report_number) {
					let a_element = '<button class="btn btn-danger btn-sm item_delete ' + scope.report.status + ' ' + accessnumber + '" buttondeleteitem><i class="fa fa-times fa-lg"></i> Delete</button>';
					label_element.html(prepend_buttons + a_element + a_export + append_buttons);
				}
				else {
					label_element.html(prepend_buttons + a_export + append_buttons);
				}
				;
				$(element).find('.panel-body').append(label_element);
				angular.element(document.getElementById('space-for-report-items')).append($compile(element)(scope));
				//let html_dropdown  = "<chartdropdown id='selector_" + chart_id +"'></chartdropdown>";
				//angular.element(document.getElementById(chart_id)).append($compile(html_dropdown)(scope));

				_retrieve_chart(scope, content_detail, element);

				if(parseInt(chart_id.split("_").pop(-1)) >= scope.max_num){
					scope.max_num = parseInt(chart_id.split("_").pop(-1));
					scope.num_report_items = scope.max_num;
				}

				scope.num_report_items++;

			}

		}
		);

		scope.$on("redrawGraphElement", function(event, id_content, type){
			let content_detail = {};
			let chart_id = id_content;
			content_detail["name"] = scope.report.content[chart_id].data.output[0];
			//content_detail["description"] = scope.report.content[chart_id].data.plotter;
			if(scope.report.content[chart_id].data.plotter != undefined){
				content_detail["selected_plotter"] = scope.report.content[chart_id].data.plotter;
			}
			if(scope.report.content[chart_id].data.parameter != undefined){
				content_detail["selected_template"] = scope.report.content[chart_id].data.parameter;
			}
			if(scope.report.content[chart_id].data.merged != undefined){
				content_detail["merged"] = scope.report.content[chart_id].data.merged;
			}

			let html_div_code = '<div class="panel panel-default" id="' + chart_id + '"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#info-heading" href="#collapse-' + chart_id + '" aria-expanded="true" aria-controls="collapse-info"><i class="fa fa-area-chart"> ' + content_detail.name + '</i></a></h4></div><div id="collapse-' + chart_id + '" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="info-heading"><div id="'+chart_id+'" class="panel-body chart"></div></div></div>';
			generate_element(scope, "plot", html_div_code);
			let element = document.getElementById(chart_id);
			let label_element  = $(document.createElement('div'));
			label_element.addClass('row');

			let accessnumber = "no_number";
			if(scope.report.number == scope.report_number){
				accessnumber = "number";
			}

			let prepend_buttons = '<div class="col-sm-12"><div class="action-buttons report-buttons pull-left">';
			let append_buttons = '</div></div>';

			let a_export  = '<div class="btn-group"><button type="button" class="btn btn-primary btn-sm dropdown-toggle item_export ' + scope.report.status + ' ' + accessnumber + '" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fa fa-download fa-lg"></i> Export Figure <span class="caret"></span></button><ul class="dropdown-menu"><li id="PNG" buttonexportitem><a>PNG</a></li><li id="JPEG" buttonexportitem><a>JPEG</a></li><li id="PDF" buttonexportitem><a>PDF</a></li></ul></div>';
			if(scope.report.status == "editable" && scope.report.number != scope.report_number) {
				let a_element = '<button class="btn btn-danger btn-sm item_delete ' + scope.report.status + ' ' + accessnumber + '" buttondeleteitem><i class="fa fa-times fa-lg"></i> Delete</button>';
				label_element.html(prepend_buttons + a_element + a_export + append_buttons);
			}
			else {
				label_element.html(prepend_buttons + a_export + append_buttons);
			}
			;
			$(element).find('.panel-body').append(label_element);
			angular.element(document.getElementById('space-for-report-items')).append($compile(element)(scope));
			//let html_dropdown  = "<chartdropdown id='selector_" + chart_id +"'></chartdropdown>";
			//angular.element(document.getElementById(chart_id)).html($compile(html_dropdown)(scope));

			_retrieve_chart(scope, content_detail, element);

		});

		//add new report item
		element.bind("click", function(){
			let left = $('.add_item').offset().left - $('.add_item').width() + 400;
			let top = $('.add_item').offset().top;
			smart_selector.display(scope.item_content.content, left, top);

			let allblocks = [];
			for(let i = 0; i < scope.report_experiments_blocks_merged_blocks.length; i++){
				allblocks.push(scope.report_experiments_blocks_merged_blocks[i]);
			}
			scope.report.common_blocks = arraysInCommon(allblocks);
		});

		//handles first selector selection (table/plot)
		if(smart_selector != undefined){
			smart_selector.onEntrySelected = function(item_selected){

				let left = $('.add_item').offset().left - $('.add_item').width() + 400;
				let top = $('.add_item').offset().top;

				let next_items_for_selector = prepareContent(scope, smart_selector.entries[smart_selector.selected_entry].identifier);
				smart_selector_detail.display(next_items_for_selector, left, top);
			};
		}

		//handles next selector detail selection
		if(smart_selector_detail != undefined){
			smart_selector_detail.onEntrySelected = function(item_selected){
				let left = $('.add_item').offset().left - $('.add_item').width() + 400;
				let top = $('.add_item').offset().top;


				let result_next_items = nextDetailContent(scope, smart_selector.entries[smart_selector.selected_entry].identifier, smart_selector_detail.entries[smart_selector_detail.selected_entry]);

				if(!result_next_items[0]){
					multiple_selector.display(result_next_items[1], left, top);
				}
			};
		}

		//handles first creation of table based on options
		if(multiple_selector != undefined){
			multiple_selector.onEntrySelected = function(item_selected, data){
				for(let i = 0; i < multiple_selector.entries.length; i++){
					if(multiple_selector.entries[i].name == item_selected){
						multiple_selector.entries[i].selected = true;
					}
				}
			};

			multiple_selector.onEntryDeselected = function(item_selected, data){
				for(let i = 0; i < multiple_selector.entries.length; i++){
					if(multiple_selector.entries[i].name == item_selected){
						multiple_selector.entries[i].selected = false;
					}
				}
			};

			multiple_selector.onClose = function(){
				//check if at least one item is selected
				let checkOneSelected = false;
				angular.forEach(multiple_selector.entries, function(value, key){
					if(value.selected)
						checkOneSelected = true;
				});

				if(checkOneSelected){
					let table_id = 'table' + '_' + scope.num_report_items;

					scope.tables_details[table_id] = multiple_selector.entries;

					let html_div_code = '<div class="panel panel-default" id="' + table_id + '"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#info-heading" href="#collapse-' + table_id + '" aria-expanded="true" aria-controls="collapse-info"><i class="fa fa-table"> Table</i></a></h4></div><div id="collapse-' + table_id + '" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="info-heading"><div class="panel-body" table-dynamic monster=' + scope.num_report_items + " tableid=" + table_id + " reportstatus=" + scope.report.status + " urlprefix=" + scope.url_prefix + '></div></div></div>';

					angular.element(document.getElementById('space-for-report-items')).append($compile(html_div_code)(scope));

					scope.report.orderedcontent.push(table_id);
					scope.num_report_items++;
				}
			};
		}

		//handles single table updates via settings option
		if(multiple_selector_updater != undefined){
			multiple_selector_updater.onEntrySelected = function(item_selected, data){
				for(let i = 0; i < multiple_selector_updater.entries.length; i++){
					if(multiple_selector_updater.entries[i].name == item_selected){
						multiple_selector_updater.entries[i].selected = true;
					}
				}
			};

			multiple_selector_updater.onEntryDeselected = function(item_selected, data){
				for(let i = 0; i < multiple_selector_updater.entries.length; i++){
					if(multiple_selector_updater.entries[i].name == item_selected){
						multiple_selector_updater.entries[i].selected = false;
					}
				}
			};

			multiple_selector_updater.onClose = function(){

				//check if at least one item is selected
				let checkOneSelected = false;
				angular.forEach(multiple_selector_updater.entries, function(value, key){
					if(value.selected)
						checkOneSelected = true;
				});

				if(checkOneSelected){
					let element = document.getElementById(multiple_selector_updater.current_table);

					$(element).attr('id', null);
					$compile(element)(scope);
					$(element).attr('id', multiple_selector_updater.current_table);
				}
			};

		};

		//Prepare the content for selector initialization
		function prepareContent(scope, content_identifier){
			let next_content_items = [];

			switch(content_identifier){
				case 'table':
					next_content_items =  scope.table_item_content.content;
					break;
				case 'plot':
					angular.forEach(scope.report_experiments, function(value, key){
						angular.forEach(value.declaration.analyzers, function(value_analyzer, key_analyzer){
							if(value_analyzer.algorithm == scope.report.analyzer){
								scope.report_experiments[key].analyzer_block = key_analyzer;
							}
						});

						let plottable_result = [];
						angular.forEach(value.results[scope.report_experiments[key].analyzer_block], function(value_result_item, key_result_item){
							if(value_result_item.type.startsWith("plot/")){
								plottable_result.push(key_result_item);
							}

						});

						scope.report_experiments[key].plottable_blocks = plottable_result;

					});

					//Results block are the same for all experiments from same analyzer.
					//So just grab information from one of them for smart_selector items
					let single_experiment = scope.report.experiments[0];

					//create smart_selector items
					angular.forEach(scope.report_experiments[single_experiment].plottable_blocks, function(value_plottable, key_plottable){
						let plot_type = scope.report_experiments[single_experiment].results[scope.report_experiments[single_experiment].analyzer_block][value_plottable].type;
						let item_dict = {};
						item_dict["identifier"] = value_plottable;
						item_dict["name"] = value_plottable;
						item_dict["description"] = plot_type;

						next_content_items.push(item_dict);
					});
					break;
			}

			return next_content_items;
		}

		//Get the detailed content for next selector
		function nextDetailContent(scope, content_identifier, sub_content){
			let is_end = false;
			let next_items = [];
			let return_contents = [];
			switch(content_identifier){
				case 'table':
					is_end = false;
					angular.forEach(scope.report_experiments, function(value, key){
						angular.forEach(value.declaration.analyzers, function(value_analyzer, key_analyzer){
							if(value_analyzer.algorithm == scope.report.analyzer){
								scope.report_experiments[key].analyzer_block = key_analyzer;
							}
						});

						let table_result = [];
						angular.forEach(value.results[scope.report_experiments[key].analyzer_block], function(value_result_item, key_result_item){
							if(!(value_result_item.type.startsWith("plot/"))){
								table_result.push(key_result_item);
							}

						});

						scope.report_experiments[key].table_result_blocks = table_result;

					});

					//Results block are the same for all experiments from same analyzer.
					//So just grab information from one of them for smart_selector items
					let single_experiment = scope.report.experiments[0];

					//create smart_selector items
					angular.forEach(scope.report_experiments[single_experiment].table_result_blocks, function(value_table_result, key_table_result){

						let table_item_data = scope.report_experiments[single_experiment].results[scope.report_experiments[single_experiment].analyzer_block][value_table_result];
						let item_dict = {};
						item_dict["identifier"] = value_table_result;
						item_dict["name"] = value_table_result;
						item_dict["description"] = table_item_data.type;
						if(table_item_data.primary)
							item_dict["selected"] = true;
						else
							item_dict["selected"] = false;
						item_dict["data"] = table_item_data;

						next_items.push(item_dict);
					});

					//adding execution time entry information for common blocks
					angular.forEach(scope.report.common_blocks, function(value_table_result, key_table_result){
						let item_dict = {};
						item_dict["identifier"] = "execution_time." + value_table_result;
						item_dict["name"] = "execution_time." + value_table_result;
						item_dict["selected"] = false;
						next_items.push(item_dict);

					});

					//adding total execution time entry information for experiment
					let item_dict = {};
					item_dict["identifier"] = "experiment.execution_time";
					item_dict["name"] = "experiment.execution_time";
					item_dict["selected"] = false;
					next_items.push(item_dict);

					//adding globals algorithms parameters
					angular.forEach(scope.report_algorithm_parameters, function(value_algorithm_parameters, key_algorithm_parameters){
						for(let i = 0; i < Object.keys(value_algorithm_parameters).length; i++){
							let item_dict = {};
							item_dict["identifier"] = "algorithm_parameter." + key_algorithm_parameters + "__" +Object.keys(value_algorithm_parameters)[i];
							item_dict["name"] = "algorithm_parameter." + key_algorithm_parameters + "__" +Object.keys(value_algorithm_parameters)[i];
							item_dict["selected"] = false;
							next_items.push(item_dict);
						}

					});

					break;
				case 'plot':
					is_end = true;
					let chart_id = 'chart_' + sub_content.identifier + '_graph' + '_' + scope.num_report_items;
					let html_div_code = '<div class="panel panel-default" id="' + chart_id + '"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#info-heading" href="#collapse-' + chart_id + '" aria-expanded="true" aria-controls="collapse-info"><i class="fa fa-area-chart"> ' + sub_content.name + '</i></a></h4></div><div id="collapse-' + chart_id + '" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="info-heading"><div id="'+chart_id+'" class="panel-body chart {$ report.status $}"></div></div></div>';
					generate_element(scope, content_identifier, html_div_code);
					let element = document.getElementById(chart_id);
					let label_element  = $(document.createElement('div'));
					label_element.addClass('row');

					let accessnumber = "no_number";
					if(scope.report.number == scope.report_number){
						accessnumber = "number";
					}

					let prepend_buttons = '<div class="col-sm-12"><div class="action-buttons report-buttons pull-left">';
					let append_buttons = '</div></div>';

					let a_export  = '<div class="btn-group"><button type="button" class="btn btn-primary btn-sm dropdown-toggle item_export ' + scope.report.status + ' ' + accessnumber + '" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fa fa-download fa-lg"></i> Export Figure <span class="caret"></span></button><ul class="dropdown-menu"><li id="PNG" buttonexportitem><a>PNG</a></li><li id="JPEG" buttonexportitem><a>JPEG</a></li><li id="PDF" buttonexportitem><a>PDF</a></li></ul></div>';
					if(scope.report.status == "editable" && scope.report.number != scope.report_number) {
						let a_element = '<button class="btn btn-danger btn-sm item_delete ' + scope.report.status + ' ' + accessnumber + '" buttondeleteitem><i class="fa fa-times fa-lg"></i> Delete</button>';
						label_element.html(prepend_buttons + a_element + a_export + append_buttons);
					}
					else {
						label_element.html(prepend_buttons + a_export + append_buttons);
					}
					$(element).find('.panel-body').append(label_element);

					angular.element(document.getElementById('space-for-report-items')).append($compile(element)(scope));

					_retrieve_chart(scope, sub_content, element);
					scope.report.orderedcontent.push(chart_id);
					break;
			}

			return_contents = [is_end, next_items];

			return return_contents;

		}

		//Generate and compile DOM element
		function generate_element(scope, content_identifier, html_div_code){
			switch(content_identifier){
				case 'table':
					angular.element(document.getElementById('space-for-report-items')).append($compile(html_div_code)(scope));
					scope.num_report_items++;
					break;
				case 'plot':
					angular.element(document.getElementById('space-for-report-items')).append($compile(html_div_code)(scope));
					scope.num_report_items++;
					break;
			}

		}

		//Retrieve chart from api and display on proper item
		function _get_chart(scope, sub_content, content_type, chart_id){
			let required_plotter = [];
			let set_plotter = '';
			if(sub_content.selected_plotter != undefined){
				//required_plotter.push(sub_content.selected_plotter);
				set_plotter = sub_content.selected_plotter;
				let requested_dataformat = '';
				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].name == sub_content.selected_plotter){
						requested_dataformat = scope.report.plotters[i].dataformat;
						break;
					}
				}

				//Get default plotter for required dataformat
				for (let i = 0; i < scope.report.defaultplotters.length; i++){
					if(scope.report.defaultplotters[i].dataformat == requested_dataformat){
						sub_content.defaultplotter = scope.report.defaultplotters[i];
						break;
					}
				}

				required_plotter.push(sub_content.defaultplotter.plotter);

				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].dataformat == requested_dataformat && scope.report.plotters[i].name != sub_content.defaultplotter.plotter){
						required_plotter.push(scope.report.plotters[i].name);
					}
				}
			}
			else{
				//Get default plotter for required dataformat
				for (let i = 0; i < scope.report.defaultplotters.length; i++){
					if(scope.report.defaultplotters[i].dataformat == sub_content.description){
						sub_content.defaultplotter = scope.report.defaultplotters[i];
						break;
					}
				}

				required_plotter.push(sub_content.defaultplotter.plotter);
				set_plotter = sub_content.defaultplotter.plotter;

				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].dataformat == sub_content.description && scope.report.plotters[i].name != sub_content.defaultplotter.plotter){
						required_plotter.push(scope.report.plotters[i].name);
					}
				}
			}

			let plotterparameter = [];
			//Get other plotterparameter
			for (let i = 0; i < scope.report.plotterparameter.length; i++){
				plotterparameter.push(scope.report.plotterparameter[i].name);
			}

			let chart_name = sub_content.name;

			let legend_experiments = '';
			let alias_experiments = [];
			for(let i = 0; i < scope.report.experiments.length; i++){
				if(i == 0)
					legend_experiments = scope.report_experiments_alias[scope.report.experiments[i]];
				else
					legend_experiments = legend_experiments+ "&" +scope.report_experiments_alias[scope.report.experiments[i]];

				alias_experiments.push(scope.report_experiments_alias[scope.report.experiments[i]]);
			}

			let request_data = {
				experiment:   alias_experiments,
				analyzer:     [scope.report.analyzer],
				output:       [chart_name],
				plotter:      set_plotter,
				legend:       legend_experiments,
				report_number:  scope.report.number,
				//height:       300,
				//width:        400,
			};

			base_url = scope.report.url_prefix;

			let plot_detail = {};
			plot_detail["required_plotter"] = required_plotter;
			plot_detail["data"] =  {
				analyzer:     [scope.report.analyzer],
				output:       [chart_name],
				plotter:      set_plotter,
			};

			if(sub_content.selected_template != undefined){// && sub_content.selected_template != "Default")
				plot_detail["selected_template"] = sub_content.selected_template;
				request_data.parameter = plot_detail["selected_template"];
			}
			else{
				plot_detail["selected_template"] = sub_content.defaultplotter.parameter;
				request_data.parameter = plot_detail["selected_template"];
			}

			if(sub_content.merged != undefined){// && sub_content.selected_template != "Default")
				plot_detail["merged"] = sub_content.merged;
				request_data.merged = plot_detail["merged"];
			}
			else{
				plot_detail["merged"] = true;
				request_data.merged = plot_detail["merged"];
			}

			beat.experiments.utils.getPlotData(base_url,
				request_data, required_plotter, plotterparameter, content_type,
				function(r_image_data, selected_content_type) {
					download(r_image_data, chart_id + "." + content_type.toLowerCase(), selected_content_type);
				}
			);
		}


		//Retrieve chart from api and display on proper item
		function _retrieve_chart(scope, sub_content, container){
			let required_plotter = [];
			let set_plotter = '';
			if(sub_content.selected_plotter != undefined){
				//required_plotter.push(sub_content.selected_plotter);
				set_plotter = sub_content.selected_plotter;
				let requested_dataformat = '';
				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].name == sub_content.selected_plotter){
						requested_dataformat = scope.report.plotters[i].dataformat;
						break;
					}
				}

				//Get default plotter for required dataformat
				for (let i = 0; i < scope.report.defaultplotters.length; i++){
					if(scope.report.defaultplotters[i].dataformat == requested_dataformat){
						sub_content.defaultplotter = scope.report.defaultplotters[i];
						break;
					}
				}

				required_plotter.push(sub_content.defaultplotter.plotter);

				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].dataformat == requested_dataformat && scope.report.plotters[i].name != sub_content.defaultplotter.plotter){
						required_plotter.push(scope.report.plotters[i].name);
					}
				}
			}
			else{
				//Get default plotter for required dataformat
				for (let i = 0; i < scope.report.defaultplotters.length; i++){
					if(scope.report.defaultplotters[i].dataformat == sub_content.description){
						sub_content.defaultplotter = scope.report.defaultplotters[i];
						break;
					}
				}

				required_plotter.push(sub_content.defaultplotter.plotter);
				set_plotter = sub_content.defaultplotter.plotter;

				//Get other plotters for required dataformat
				for (let i = 0; i < scope.report.plotters.length; i++){
					if(scope.report.plotters[i].dataformat == sub_content.description && scope.report.plotters[i].name != sub_content.defaultplotter.plotter){
						required_plotter.push(scope.report.plotters[i].name);
					}
				}
			}

			let plotterparameter = [];
			//Get other plotterparameter
			for (let i = 0; i < scope.report.plotterparameter.length; i++){
				plotterparameter.push(scope.report.plotterparameter[i].name);
			}

			let chart_name = sub_content.name;

			let legend_experiments = '';
			let alias_experiments = [];

			for(let i = 0; i < scope.report.experiments.length; i++){
				if(i == 0)
					legend_experiments = scope.report_experiments_alias[scope.report.experiments[i]];
				else
					legend_experiments = legend_experiments+ "&" +scope.report_experiments_alias[scope.report.experiments[i]];

				if(Object.keys(scope.$parent.report_experiments_alias_from_content).length === 0)
					alias_experiments.push(scope.report_experiments_alias[scope.report.experiments[i]]);
				else
					alias_experiments.push(scope.report_experiments_alias_from_content[scope.report.experiments[i]]);
			}

			let request_data = {
				experiment:   alias_experiments,
				analyzer:     [scope.report.analyzer],
				output:       [chart_name],
				plotter:      set_plotter,
				legend:       legend_experiments,
				report_number: scope.report.number,
				//height:       300,
				//width:        400,
			};

			base_url = scope.report.url_prefix;
			//scope.plots_details[container.id];

			let plot_detail = {};
			plot_detail["required_plotter"] = required_plotter;
			plot_detail["data"] =  {
				analyzer:     [scope.report.analyzer],
				output:       [chart_name],
				plotter:      set_plotter,
			};


			if(sub_content.selected_template != undefined){// && sub_content.selected_template != "Default")
				plot_detail["selected_template"] = sub_content.selected_template;
				request_data.parameter = plot_detail["selected_template"];
			}
			else{
				plot_detail["selected_template"] = sub_content.defaultplotter.parameter;
				request_data.parameter = plot_detail["selected_template"];
			}

			if(sub_content.merged != undefined){// && sub_content.selected_template != "Default")
				plot_detail["merged"] = sub_content.merged;
				request_data.merged = plot_detail["merged"];
			}
			else{
				plot_detail["merged"] = true;
				request_data.merged = plot_detail["merged"];
			}

			scope.plots_details[container.id]= plot_detail;

			if(scope.report.status == "editable" && scope.report.number != scope.report_number){
				beat.experiments.utils.displayPlot(base_url, $(container).find('.panel-body')[0],
					request_data, required_plotter, plotterparameter, false,

					function(r_plotter, r_plotterparameter, r_merged) {
						scope.plots_details[container.id]["data"]["plotter"] = r_plotter;
						scope.plots_details[container.id]["selected_template"] = r_plotterparameter;
						scope.plots_details[container.id]["merged"] = r_merged;
					}
				);
			}
			else{
				beat.experiments.utils.displayPlot(base_url, $(container).find('.panel-body')[0],
					request_data, [], [], false,

					function(r_plotter, r_plotterparameter, r_merged) {
					}
				);
			}
		}

		function arraysInCommon(arrays){
			let i, common,
				L= arrays.length, min= Infinity;
			while(L){
				if(arrays[--L].length<min){
					min= arrays[L].length;
					i= L;
				}
			}
			common= arrays.splice(i, 1)[0];
			return common.filter(function(itm, indx){
				if(common.indexOf(itm)== indx){
					return arrays.every(function(arr){
						return arr.indexOf(itm)!= -1;
					});
				}
			});
		}

	};
});

