/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Dynamic tables items
angular.module('reportApp').directive('item', function ($compile) {
	function createTDElement(column) {
		let table = angular.element('<table><tr><td class="tableitemspace" thecolumn="' + column + '"></td></tr></table>');
		return table.find('td');
	}

	function render(element, scope) {
		let column, html, i;
		let columns = scope.$parent.tables_details[scope.$parent.dattrs.tableid];

		for (i = 0; i < columns.length ; i++) {
			if(i == 0 && columns.length > 0){
				html = $compile(createTDElement("experiment"))(scope);

			}
			column = columns[i];
			if (column.selected) {

				html = $compile(createTDElement(column.name))(scope);
				element.append(html);
			}
		}


	}

	return {
		//   restrict: 'A',
		scope: {
			exp_name: "=",
			item: "=",
			columns: "="
		},
		compile: function () {
			return function (scope, element) {
				render(element, scope);
			};

		}
	};

});

