/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Directive for opening smart_selector list on "Add a report item" button click that displays options
angular.module('reportApp').directive("publishreport", function($compile){
	return function(scope, element, attrs){
		//add new report item
		element.bind("click", function(){
			publishReport();
		});


		function publishReport(){
			scope.reportFactory.publishReportAlgorithms(scope.user, scope.report_id, scope.url_prefix)
			.success(function (reportData){
				beat.ui.report.publish_report('report_publish', scope, reportData);
			})
			.error(function (error){
				scope.status = 'Unable to publish report data: ' + error;
				$(".explanation_text").hide();
				$("#report_publish .warnings").hide();
				$("#report_publish .errors").show();
				if(error.detail != undefined)
					scope.status = 'Unable to publish report data: ' + error.detail;
				$("#report_publish .errors .errorslist").append(scope.status);
				$("#button-report_publish-cancel").hide();
			});


		}
	};
});

