/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Directive for opening smart_selector list on "Add a report item" button click that displays options
angular.module('reportApp').directive("savereportitems", ['$compile', 'ReportService', function($compile, ReportService){
	return function(scope, element, attrs){
		//add new report item
		element.bind("click", function(){
			//let savecontent = [];
			let savecontent = {};
			if(scope.plots_details != undefined){
				angular.forEach(scope.plots_details, function(value, key){
					//savecontent.push(key, value);
					savecontent[key] = value;
				});
			}
			if(scope.tables_details != undefined){
				angular.forEach(scope.tables_details, function(value, key){
					savecontent[key] = value;
					//savecontent.push(key, value);
				});

				if(scope.floating_point_precision.selected != undefined){
					savecontent["floating_point_precision"] = scope.floating_point_precision.selected;
				}
			}
			if(scope.report_experiments_alias != undefined){
				let alias_experiments = {};
				angular.forEach(scope.report_experiments_alias, function(value, key){
					alias_experiments[key] = value;
				});
				savecontent["alias_experiments"] = alias_experiments;
			}

			if(!(jQuery.isEmptyObject(scope.sorted_experiments_keys_tables)) && !(jQuery.isEmptyObject(scope.sorted_experiments_keys_reverse)) && !(jQuery.isEmptyObject(scope.sorted_experiments_keys_tables_sortkey))){
				savecontent["sorted_tables_experiments"] = scope.sorted_experiments_keys_tables;
				savecontent["sorted_tables_alias_experiments"] = scope.sorted_experiments_alias_keys_tables;
				savecontent["sorted_tables_keys_reverse"] = scope.sorted_experiments_keys_reverse;
				savecontent["sorted_tables_sortkey"] = scope.sorted_experiments_keys_tables_sortkey;
			}

			// save group data
			savecontent['groups'] = ReportService.serializeGroups();

			//call set report content from factory
			let mydict = {};
			mydict["experiments"] = scope.report.experiments;
			mydict["content"] = savecontent;

			for(let i = 0; i < scope.report.experiments.length; i++){
				scope.report_experiments_alias_from_content[scope.report.experiments[i]] = scope.report_experiments_alias[scope.report.experiments[i]];
			}

			updateReport(mydict);
		});


		function updateReport(data){
			scope.reportFactory.updateReport(scope.user, scope.report_id, data, scope.url_prefix)
			.success(function (reportData){
				//alert("The report "+ scope.report_id +" has been saved.");

				beat.ui.report.report_saved('report_saved', scope);
			})
			.error(function (error){
				scope.status = 'Unable to update report data: ' + error.message;

			});

		}
	};
}]);


