/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Directive used to handle table settings click
angular.module('reportApp').directive("sortdata", function($compile){
	return {
		link:function(scope, element, attrs){
			element.bind("click", function(){
				let the_parent = scope.$parent.$parent.$parent.$parent;
				let analyzer_block = undefined;
				let report_experiments = the_parent.report_experiments;
				let report = the_parent.report;
				let table_id = attrs.sorttblid;   //get table id
				the_parent.sorted_tables.push(table_id);

				if(the_parent.sorted_experiments_keys_reverse[table_id] == undefined){
					the_parent.sorted_experiments_keys_reverse[table_id] = true;
				}
				else{
					the_parent.sorted_experiments_keys_reverse[table_id] = !the_parent.sorted_experiments_keys_reverse[table_id];
				}

				the_parent.sorted_experiments_keys_tables_sortkey[table_id] = attrs.sortth;   //set the sortKey to the param passed

				if(the_parent.sorted_experiments_keys_tables_sortkey[table_id] != "experiment"){
					let local_sort_list = [];

					if(analyzer_block == undefined){
						angular.forEach(report_experiments, function(value, key){
							angular.forEach(value.declaration.analyzers, function(value_analyzer, key_analyzer){
								if(value_analyzer.algorithm == report.analyzer && (key_analyzer in report_experiments[key].declaration.analyzers)){
									report_experiments[key].analyzer_block = key_analyzer;
									analyzer_block = report_experiments[key].analyzer_block;
								}
							});
						});
					}

					if(the_parent.sorted_experiments_keys_tables_sortkey[table_id].indexOf("execution_time.") == 0){
						//execution time information
						let block_name = the_parent.sorted_experiments_keys_tables_sortkey[table_id].split("execution_time.")[1].split("[s]")[0];
						angular.forEach(report_experiments, function(value, key){
							let local_sort_dict = {};
							local_sort_dict["experiment"] = key;
							let itemValue = "";

							if(Object.keys(report_experiments[key].execution_info).length === 0){
								itemValue = "-";
							}
							else{
								if(report_experiments[key].execution_info[block_name] == undefined){
									itemValue = "-";
								}
								else{
									itemValue = (report_experiments[key].execution_info[block_name].linear_execution_time);
								}
							}

							local_sort_dict["value"] = itemValue;
							local_sort_list.push(local_sort_dict);
						});
					}
					else if(the_parent.sorted_experiments_keys_tables_sortkey[table_id].indexOf("experiment.") == 0){
						//total execution time information
						let block_name = the_parent.sorted_experiments_keys_tables_sortkey[table_id].split("execution_time.")[1];

						angular.forEach(report_experiments, function(value, key){
							let local_sort_dict = {};
							local_sort_dict["experiment"] = key;
							let itemValue = "";
							let total_time = 0;

							if(Object.keys(report_experiments[key].execution_info).length === 0){
								total_time = "-";
							}
							else{
								angular.forEach(report_experiments[key].execution_info, function(value, key){
									total_time += value.linear_execution_time;
								});
							}

							itemValue = total_time;

							local_sort_dict["value"] = itemValue;
							local_sort_list.push(local_sort_dict);
						});
					}
					else if(the_parent.sorted_experiments_keys_tables_sortkey[table_id].indexOf("algorithm_parameter.") == 0){
						//total execution time information
						let block_name = the_parent.sorted_experiments_keys_tables_sortkey[table_id].split("algorithm_parameter.")[1];
						let algorithm_name = block_name.split("__")[0];
						let parameter_name = block_name.split("__")[1];

						angular.forEach(report_experiments, function(value, key){

							let local_sort_dict = {};
							local_sort_dict["experiment"] = key;
							let itemValue = "";

							if(the_parent.report_algorithm_parameters_experiment[key][algorithm_name] != undefined){
								let value = "";
								if(the_parent.report_algorithm_parameters_experiment[key][algorithm_name][parameter_name] != undefined){
									for(let i = 0; i < the_parent.report_algorithm_parameters_experiment[key][algorithm_name][parameter_name].length; i++){
										if(i > 0 && i < the_parent.report_algorithm_parameters_experiment[key][algorithm_name][parameter_name].length -1 ){
											value += ",";
										}
										value = the_parent.report_algorithm_parameters_experiment[key][algorithm_name][parameter_name][i];
									}
								}
								else if(the_parent.report["all_experiments"][key]["declaration"]["globals"][algorithm_name][parameter_name] != undefined){
									//get globals value
									value = the_parent.report["all_experiments"][key]["declaration"]["globals"][algorithm_name][parameter_name];
								}
								else{
									//nothing is defined
									value = "-";
								}

								itemValue = value;
							}
							else{
								itemValue = "-";
							}

							local_sort_dict["value"] = itemValue;
							local_sort_list.push(local_sort_dict);
						});
					}
					else{
						//results information
						angular.forEach(report_experiments, function(value, key){
							let local_sort_dict = {};
							local_sort_dict["experiment"] = key;
							local_sort_dict["value"] = report_experiments[key].results[analyzer_block][the_parent.sorted_experiments_keys_tables_sortkey[table_id]].value;

							local_sort_list.push(local_sort_dict);

						});

					}

					if(the_parent.sorted_experiments_keys_reverse[table_id]){
						local_sort_list.sort(function(a, b){
							return a.value - b.value;
						});
					}
					else{
						local_sort_list.sort(function(a, b){
							return b.value - a.value;
						});
					}

					the_parent.sorted_experiments_keys_tables[table_id] = [];
					the_parent.sorted_experiments_alias_keys_tables[table_id] = [];
					for(let i = 0; i < local_sort_list.length; i++){
						the_parent.sorted_experiments_keys_tables[table_id].push(local_sort_list[i]["experiment"]);
						if(the_parent.report.status ==  "editable"){
							the_parent.sorted_experiments_alias_keys_tables[table_id].push(the_parent.report_experiments_alias[local_sort_list[i]["experiment"]]);
						}
					}

				}
				else{
					let experiments_aliases = [];
					for(let i = 0; i < the_parent.report.experiments.length; i++){
						let experiment_name  = the_parent.report.experiments[i];
						let experiment_alias = the_parent.report_experiments_alias[experiment_name];
						experiments_aliases.push(experiment_alias);
					}

					if(the_parent.sorted_experiments_keys_reverse[table_id]){
						experiments_aliases.sort(function(a, b){
							return a.value - b.value;
						});
					}
					else{
						experiments_aliases.reverse(function(a, b){
							return b.value - a.value;
						});
					}

					the_parent.sorted_experiments_keys_tables[table_id] = [];
					the_parent.sorted_experiments_alias_keys_tables[table_id] = [];
					for(let i = 0; i < experiments_aliases.length; i++){
						for(let the_experiment_key in the_parent.report_experiments_alias){
							if(the_parent.report_experiments_alias[the_experiment_key] == experiments_aliases[i]){
								the_parent.sorted_experiments_keys_tables[table_id].push(the_experiment_key);
								if(the_parent.report.status ==  "editable"){
									the_parent.sorted_experiments_alias_keys_tables[table_id].push(the_parent.report_experiments_alias[the_experiment_key]);
								}
							}

						}
					}
				}

				let name_to_remove = "experiment";
				let tables_details = the_parent.tables_details[table_id];
				for(let i = 0; i < tables_details.length; i++){
					if(tables_details[i].name == "experiment"){
						tables_details.splice(i,1);
						break;
					}
				}

				let element = document.getElementById(table_id);

				$(element).attr('id', null);
				$compile(element)(scope.$parent.$parent);
				$(element).attr('id', table_id);
			});
		}
	};
});

