/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Directive used to set proper item value in selected column
angular.module('reportApp').directive("thecolumn",['$compile', function ($compile) {

	return {
		scope: {
			thecolumn: "@"
		},
		restrict: 'A',
		template: '{{itemValue}}',
		controller: ['$scope', function ($scope) {

			let the_parent = $scope.$parent.$parent.$parent.$parent;
			let report_experiments = $scope.$parent.$parent.$parent.$parent.report_experiments;
			let report_experiments_alias = $scope.$parent.$parent.$parent.$parent.report_experiments_alias;
			let floating_point_precision = $scope.$parent.$parent.$parent.$parent.floating_point_precision;
			let report = $scope.$parent.$parent.$parent.report;
			let experiment_name = $scope.$parent.item;

			if(jQuery.isEmptyObject(report_experiments) || (report_experiments[experiment_name] == undefined)){
				return;
			}

			let analyzer_block = report_experiments[experiment_name].analyzer_block;
			let report_algorithm_parameters_experiment = $scope.$parent.$parent.$parent.$parent.report_algorithm_parameters_experiment;

			if($scope.thecolumn != "experiment"){
				if(analyzer_block == undefined){
					angular.forEach(report_experiments, function(value, key){
						angular.forEach(value.declaration.analyzers, function(value_analyzer, key_analyzer){
							if(value_analyzer.algorithm == report.analyzer && (key_analyzer in report_experiments[experiment_name].declaration.analyzers)){
								report_experiments[experiment_name].analyzer_block = key_analyzer;
								analyzer_block = report_experiments[experiment_name].analyzer_block;
							}
						});
					});
				}

				if($scope.thecolumn.indexOf("execution_time.") == 0){
					//execution time information
					let block_name = $scope.thecolumn.split("execution_time.")[1].split("[s]")[0];
					if(Object.keys(report_experiments[experiment_name].execution_info).length === 0){
						$scope.itemValue = "-";
					}
					else{
						if(report_experiments[experiment_name].execution_info[block_name] == undefined){
							$scope.itemValue = "-";
						}
						else{
							$scope.itemValue = (report_experiments[experiment_name].execution_info[block_name].linear_execution_time).toFixed(floating_point_precision.selected);;
						}
					}
				}
				else if($scope.thecolumn.indexOf("experiment.") == 0){
					//total execution time information
					let block_name = $scope.thecolumn.split("execution_time.")[1];
					let total_time = 0;
					if(Object.keys(report_experiments[experiment_name].execution_info).length === 0){
						total_time = "-";
					}
					else{
						angular.forEach(report_experiments[experiment_name].execution_info, function(value, key){
							total_time += value.linear_execution_time;
						});
					}

					$scope.itemValue = total_time.toFixed(floating_point_precision.selected);
				}
				else if($scope.thecolumn.indexOf("algorithm_parameter.") == 0){
					//total execution time information
					let block_name = $scope.thecolumn.split("algorithm_parameter.")[1];
					let algorithm_name = block_name.split("__")[0];
					let parameter_name = block_name.split("__")[1];
					if(report_algorithm_parameters_experiment[experiment_name][algorithm_name] != undefined){
						let value = "";
						if(report_algorithm_parameters_experiment[experiment_name][algorithm_name][parameter_name] != undefined){
							for(let i = 0; i < report_algorithm_parameters_experiment[experiment_name][algorithm_name][parameter_name].length; i++){
								if(i > 0 && i < report_algorithm_parameters_experiment[experiment_name][algorithm_name][parameter_name].length -1 ){
									value += ",";
								}
								value = report_algorithm_parameters_experiment[experiment_name][algorithm_name][parameter_name][i];
							}
						}
						else if(report["all_experiments"][experiment_name]["declaration"]["globals"][algorithm_name][parameter_name] != undefined){
							//get globals value
							value = report["all_experiments"][experiment_name]["declaration"]["globals"][algorithm_name][parameter_name];
						}
						else{
							//nothing is defined
							value = "-";
						}

						$scope.itemValue = value;
					}
					else{
						$scope.itemValue = "-";
					}
				}
				else{
					//results information
					$scope.itemValue = (report_experiments[experiment_name].results[analyzer_block][$scope.thecolumn].value).toFixed(floating_point_precision.selected);
				}
			}
			else{
				let experiment_alias = report_experiments_alias[experiment_name];
				$scope.itemValue = experiment_alias;
			}
		}]//,
		//link: function(scope, element, attrs)
		//{
		//  console.log(scope);
		//  let report_experiments_alias = scope.$parent.$parent.$parent.$parent.report_experiments_alias;
		//  let experiment_name = scope.$parent.item;
		//  let experiment_alias = report_experiments_alias[experiment_name];
		//  scope.$watch(scope.$parent.$parent.$parent.$parent.report_experiments_alias,function(newValue, oldValue)
		//  {
		//      console.log("changed");
		//      console.log(report_experiments_alias);
		//      console.log(oldValue);
		//      console.log(newValue);
		//  });
		//
		//}
	};
}]);

